fun die s = (TextIO.output(TextIO.stdErr, s ^ "\n");
             OS.Process.exit OS.Process.failure);

fun read_data acc lnum =
  case TextIO.inputLine TextIO.stdIn of
      NONE => acc
    | SOME str =>
      (case Int.fromString str of
           NONE => die (Int.toString lnum ^ ": bad line: " ^ str)
         | SOME i => read_data (i::acc) (lnum + 1))

fun sum t c [] = (t, c)
  | sum t c (h::rest) = sum (t + h) (c + 1) rest

fun square (r:real) = r * r

fun main() =
  let
    val data = read_data [] 1
    val _ = not (null data) orelse die "No data!"
    val (total, count) = sum 0 0 data
    val mean = real total / real count
    val sqdiffs = List.foldl (fn (i,a) => a + square (real i - mean)) 0.0 data
  in
    print (Int.toString count ^ " " ^ Real.toString mean ^
           (if count > 1 then
              " " ^ Real.toString (Math.sqrt (sqdiffs / (real (count - 1))))
            else "") ^ "\n")
  end
